// Copyright 2017-2021, Schlumberger
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <vector>
#include <cstdint>
#include <functional>

namespace Test_Utils {
#if 0
}
#endif

// Free functions

#ifdef HAVE_SD

void copy_sd_to_sd(const std::string& srcname, const std::string& dstname);
std::vector<std::int64_t> get_segsizes(const std::string& name);
std::function<std::string()> get_token_callback();
std::vector<std::pair<std::string,std::int64_t>> get_segments(const std::string& name);
void copy_sd_to_folder(const std::string& srcname, const std::string& dstname, int verbose);
void copy_folder_to_sd(const std::string& srcname, const std::string& dstname, int verbose);

#endif

} // namespace
